<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<?php
/******************************************************************
 * This is the admin system.  I'm going to do it all in one large *
 * file.  I like to just keep it all together.				*
 * Modified by Nick Vrtis: nick@vrtisworks.com V3.1			*
 * 1) Added 'Change' function to allow changes to title and		*
 *    description.								*
 * 2) Added 'Delete' function to remove a picture.			*
 * 3) Added confirmation screen after changes made (or an add).	*
 * Modified by Nick Vrtis: nick@vrtisworks.com V3.2			*
 * 1) Fixed thumbnail size usage when adding new picture.		*
 * 2) Added optional use of external Image Magick instead of	*
 *		GD that might not be included in PHP.				*
 * 3) Added comments to document layout of the 'albums.db' file.	*
 * 4) Changed the any ' in the title with ` to avoid problems	*
 *		with the 'on click' code in the viewer.				*
 * THINGS TO DO:									*
 *  1)This program only works with JPG images.  Should be		*
 *       expanded to handle other formats.				*
 *		NOTE: Image Magick will handle a lot more formats, so this	*
 *			might not be as hard as it looks.				*
 *  2)Need to add editing/deletes for directories/albums.		*
 *	 3)Confirmations on Add/Update go back to main page.  They	 *
 *	 	   should be smart enough to go back to where they came	 *
 *		   from.  	 	 	     	  	    	    	   		 *
 ******************************************************************/
/******************************************************************
 * Change the following to change the base directory for all the	 *
 * files and things that MyPhotoAlbum stores.  If necessary,	 *
 * this will be created the first time this module is run.		 *
 ******************************************************************/
$baseAlbumDir = "PhotoAlbums";

/******************************************************************
 If the 'convertor' is set = "", then the GD libraries must be
 included in PHP, along with the JPG support.  As an alternative
 'convertor' can be set to the path of the convert program that
 is available if Image Magick is installed on you system (try
 'whereis convert' to find it. 
 ******************************************************************/
$convertor = "/usr/bin/X11/convert";
/******************************************************************
 * DEFAULT settings.  These changes will be global.			 *
 ******************************************************************/
$defaultAlbum = "MyAlbum";
$defaultAlbumTitle = "My Photo Album";
$defaultThumbScale = 80;
$defaultAlbumDesc = "Here is a collection of my favorite pictures";

function FindAlbumInfo($theDir) {
/******************************************************************
 * Finds the directory information in 'albums.db' and sets the	 *
 * globals $AlbumDir and $AlbumInfo[n]	  	     			 *
 * [0] = Name of the directory.
 * [1] = Title for the album.
 * [2] = Size for the thumbnails.
 * [3] = Description for the album.
 ******************************************************************/
global $AlbumDir;
global $AlbumInfo;
global $baseAlbumDir;

$AlbumDir = $baseAlbumDir."/".$theDir;

// 'AlbumInfo' is much more complicated
$adb = fopen($baseAlbumDir."/"."albums.db",'r');
while ($AlbumInfo = fgetcsv($adb,1000)) {
		if ($AlbumInfo[0]==$theDir) {
		   return;
		}
}
//Note that if 'theDir' is not found, 'AlbumInfo' will be empty
}

function OnePicture($theTitle, $theDesc, $theSeq, $thePicture, $options ) {
/******************************************************************
 * This function will format and output the table rows and values *
 * for a picture.									*
 * NOTE: if 'thePicture' is null, then the file select input	*
 *		format will be used.						*
 ******************************************************************/

global $AlbumDir;
global $baseAlbumDir;

if ($options=="edit") {	//See if need to put up the edit version
	print "<tr>";
	if ($thePicture) {	//Two rows if we have a picture/three if not
		print "<td align=\"center\" valign=\"top\" rowspan=\"2\">";
		print "<img src=\"$AlbumDir/thumbs/$thePicture\" alt=\"$theTitle\" border=\"0\"></a></td>";
		print "<td align=\"right\" valign=\"top\">";
		print "<b>Title:</b></td>";
		print "<td align=\"left\" valign=\"top\">";
		print "<input type=\"text\" name=\"title\" size=\"40\" maxlength=\"40\" value=\"$theTitle\"></td>";
		print "<td align=\"center\" valign=\"top\" rowspan=\"2\">";
		print "<b>Description:</b><textarea name=\"description\" cols=\"40\" rows=\"5\">$theDesc</textarea></td>";
	} else {
		print "<td align=\"right\" valign=\"top\">";
		print "<b>Picture File:</b></td>";
		print "<td align=\"left\" valign=\"top\">";
		print "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"10000000\">";
		print "<input type=\"file\" name=\"userfile\" value=\"*.jpg\"></td>";
		print "<td align=\"center\" valign=\"top\" rowspan=\"3\">";
		print "<b>Description:</b><textarea name=\"description\" cols=\"40\" rows=\"5\">$theDesc</textarea></td>";
		print "</tr>";
		print "<tr>";
		print "<td align=\"right\" valign=\"top\">";
		print "<b>Title:</b></td>";
		print "<td align=\"left\" valign=\"top\">";
		print "<input type=\"text\" name=\"title\" size=\"40\" maxlength=\"40\" value=\"$theTitle\"></td>";
	}
	print "</tr>";
	print "<tr>";
	print "<td align=\"right\" valign=\"top\">";
	print "<b>Sequence:</b></td>";
	print "<td align=\"left\" valign=\"top\">";
	print "<input type=\"text\" name=\"newseq\" size=\"10\" maxlength=\"10\" value=\"$theSeq\"></td>";
	print "</tr>";
}else {
	print "<tr>";
	print "<td align=\"center\" valign=\"bottom\" rowspan=\"2\">";
	if ($options=="clickable") {
		$simpledir = str_replace($baseAlbumDir."/","",$AlbumDir);
		print "<a href=\"$PHP_SELF?submit=UpdatePicture&picture=$thePicture&albumdir=$simpledir\"><img src=\"$AlbumDir/thumbs/$thePicture\" alt=\"$theTitle\" border=\"0\"></a></td>";
	} else {
		print "<img src=\"$AlbumDir/thumbs/$thePicture\" alt=\"$theTitle\" border=\"0\"></td>";
	}
	print "<td align=\"justify\" valign=\"top\">";
	print "<b>Title: </b>$theTitle</td>";
	print "<td align=\"justify\" valign=\"top\" rowspan=\"2\">";
	print "$theDesc</td>";
	print "</tr>";

	print "<tr>";
	print "<td align=\"justify\" valign=\"top\"><b>Sequence: </b>$theSeq</td>";
	print "</tr>";
}

}
?>
<html>
<head>
<title>My Photo Album: Administration Form V3.2</title>
<link rel="stylesheet" type="text/css" media="screen" href="mpastyles.css">
<script>
wherefrom = '';

function setfrom(whichbutton){
	wherefrom = whichbutton;	/* Save which submit button got pressed */
}
/****************************************************************************
 * This function checks to make sure that they really want to make the change
 ****************************************************************************/
function grandmother(){
	if (wherefrom == 'C') {		/* Do the grandmother thing before permanent changes */
		return true;}
	if (wherefrom == 'U') {
		if (confirm("Do you really want to update the information?")) {
			return true;}
		else {return false;}
	}
	if (wherefrom == 'D') {
		if (confirm("Should I delete this picture?")) {
			return true;}
		else {return false;}
	}
	return false;	/* How did I get this far? */
}
</script>
</head>
<body>

<table width="100%" cellpadding=0 cellspacing=0>
	<tr><td align="left" valign="top" class="header">My Photo Album: Administration Panel</td>
   <td align="right" valign="top" class="header"><sup>Version 3.2</sup>
   </td></tr></table>
<br><br>
<center>

<?php
if ($submit == "Add Picture")
{
/******************************************************************
 * ADD PICTURE - here's were we actually add the picture after	*
 *  the user entered the file name and description.			* 
 ******************************************************************/
FindAlbumInfo($albumdir);
?>
<form action="<?=$PHP_SELF?>" method="post" enctype="multipart/form-data">
<table cellspacing=0 cellpadding=5 frame="box">
<tr>
	<td align="center" class="title" colspan=3>
		Added Picture in <?=$AlbumInfo[1]?>
	</td>
</tr>
<?php	
/******************************************************************
 * The format of the pictures.db file is:					*
 * [0]=The short title of the picture.					*
 * [1]=The name of the full size picture.					*
 * [2]=The name of the thumbnail picutre (should be the same as	*
 *	 the full size.								*
 * [3]=The description								*
 * NOTE: The file is kept in physical sequence that the pictures	*
 *		should be displayed in. The sequence numbers are		*
 *		calculated on the fly just to allow the user to 	*
 *		change to order or insert a new picture in a slot.	*
 ******************************************************************/
	$pic_name = time().".jpg";	/* Create a unique name for the picture */
	/* Move the full size picture to the 'pictures' directory */
	if (move_uploaded_file ($userfile, "$AlbumDir/pictures/$pic_name"))
	{	
		chmod ("$AlbumDir/pictures/$pic_name", 0664); /* Make sure server can read it */
		
		/* Create the thumbnail image from the original */
      $new_w = $AlbumInfo[2];
		if ($convertor == "") {
			$src_img = imagecreatefromjpeg("$AlbumDir/pictures/$pic_name");
			$new_h = imagesy($src_img) / (imagesx($src_img) / $new_w);
			$dst_img = imagecreate($new_w,$new_h);
			imagecopyresized($dst_img,$src_img,0,0,0,0,$new_w,$new_h,imagesx($src_img),imagesy($src_img));
			imagejpeg($dst_img, "$AlbumDir/thumbs/$pic_name");
		} else {
      	exec ($convertor." -size $new_w"."x$new_w -geometry $new_w"."x$new_w> -quality 80 ".$AlbumDir."/pictures/".$pic_name." ".$AlbumDir."/thumbs/".$pic_name);
      }
		chmod ("$AlbumDir/thumbs/$pic_name", 0664);
		
		$description = stripslashes($description);	/* Get rid of URL encoding */
		$title = stripslashes($title);
      $title = str_replace("'","`",$title);		/* Encode ' because it's in a view */
		/* Change quotes to HTML &quot so they don't interfere with 'fgetcsv' */
		$db_output = "\"".str_replace('"','&quot ',$title)."\",\"$pic_name\",\"$pic_name\",\"".str_replace('"','&quot ',$description)."\";\n";
		if ($newseq == "At end") {
			//Adding at the end is simple....  Just append the record.
			$fp = fopen("$AlbumDir/pictures.db","a");
			fputs($fp,$db_output);
			fclose($fp);
		}
		else {	//Adding in sequence is a lot more complicated...
			$fp = fopen ("$AlbumDir/pictures.db",'r');
			$fout = fopen("$AlbumDir/pictures.dbnew","w");	/* Create new output file */
			$data = fgets($fp,100000); /* copy the 'header' line */
			fputs($fout,$data,strlen($data));

			/* Find the picture information in the pictures.db file */
			$picseq = 10;
			$nextseq = $picseq+10;
			$newseq = 0+$newseq;	//Force 'newseq' to numerics
			while ($data = fgets($fp,100000))	//Don't really need to look at the data.. just copy
			{
				//See if 'newseq' is between the current and next.. that means we want to insert new one here.
				if (($newseq > $picseq) && ($newseq < $nextseq)) {
					fputs($fout,$data,strlen($data));	//Write out the 'picseq' record, then the new one.
					fputs($fout,$db_output);
				}
				else {
					fputs($fout,$data,strlen($data));	//Write the updated information
				}
				$picseq+=10;
				$nextseq+=10;
			}
			fclose ($fp);		/* Close the original pictures.db */
			fclose ($fout);		/* Then the new one */

			chmod("$AlbumDir/pictures.dbnew",0664);		// Make sure permissions OK
			if (file_exists("$AlbumDir/pictures.dbold"))	// See if there was a backup left...
			{
				unlink("$AlbumDir/pictures.dbold");		// Get rid of the old one
			}
			copy("$AlbumDir/pictures.db","$AlbumDir/pictures.dbold");	// Save a copy 'just in case'
			chmod("$AlbumDir/pictures.dbold",0664);
			copy("$AlbumDir/pictures.dbnew","$AlbumDir/pictures.db");
		}
		OnePicture($title, $description, $newseq, $pic_name, "display");
	}
	else {
		print "<tr><td align=\"center\" colspan=3>Upload failed.</td></td>";
	}
	?>
	<tr>
	<td align="center" colspan=3>
		<input type="submit" name="submit" value="<?=$submit?> complete">
	</td>
	</tr>
	</table>
	</form>
<?php
}
elseif (($submit == "Delete Picture") || ($submit == "Update Information"))
{
/******************************************************************
 * DELETE PICTURE - Deletes the reference to the picture, and 	*
 *  deletes both the full size picture and the thumbnail.		*
 * UPDATE INFORMATION - Most of the code is the				*
 *  same as delete, so they are common.					*
 * NOTE: These are called after the confirmation/grandmother has	*
 *  verified that they really want to.					*
 ******************************************************************/
 FindAlbumInfo($albumdir);
?>
<form action="<?=$PHP_SELF?>" method="post" enctype="multipart/form-data">
<table cellspacing=0 cellpadding=5 frame="box">
<tr>
	<td align="center" class="title" colspan=3>
		<i><?=$submit?> in:</i> <?=$AlbumInfo[1]?>
	</td>
</tr>
<?php
if (!$fp = @fopen ("$AlbumDir/pictures.db",'r') )
{
	print "$AlbumDir/pictures.db is not configured yet.";	/*Not sure how we could have gotten here */
	exit;
}
$fout = fopen("$AlbumDir/pictures.dbnew","w");	/* Create new output file */
$data = fgets($fp,100000); /* copy the 'header' line */
fputs($fout,$data,strlen($data));

/* Find the picture information in the pictures.db file */
$picseq = 10;
$nextseq = $picseq+10;
$newseq = 0+$newseq;	//Force 'newseq' to numerics
$description = stripslashes($description);	//Make it look pretty for display
$title = stripslashes($title);
$title = str_replace("'","`",$title);		/* Encode ' because it's in a view */
OnePicture($title, $description, $newseq, $picture, "display");
//NOTE: for a delete, the picture may still be in browser cache by the time the user sees the display
while ($data = fgetcsv($fp,1000) )
{
	if ($data[1] == $picture)	//See if this is the picture we want to do something with
	{					//YES
		if (($submit == "Update Information")  && ($newseq == $picseq)) {	//If update, I can display the picture
			$db_output = "\"".str_replace('"','&quot ',$title)."\",\"$picture\",\"$picture\",\"".str_replace('"','&quot ',$description)."\";\n";
			fputs($fout,$db_output);	//Write the updated information
		}						//Skip the write if a delete or sequence changed
	} elseif (($newseq<10) && ($picseq==10) && ($submit == "Update Information")) {
			//See if 'newseq' is < 10 & 'picseq' == 10  --> We want to add at the beginning.
			$db_output = "\"".str_replace('"','&quot ',$title)."\",\"$picture\",\"$picture\",\"".str_replace('"','&quot ',$description)."\";\n";
			fputs($fout,$db_output);	//Write out the 'newseq' record, then the old one.
			$db_output = "\"".str_replace('"','&quot ',$data[0])."\",\"$data[1]\",\"$data[2]\",\"".str_replace('"','&quot ',$data[3])."\";\n";
			fputs($fout,$db_output);	//Write the updated information
	} elseif (($newseq > $picseq) && ($newseq < $nextseq) && ($submit == "Update Information")) { 
			//See if 'newseq' is between the current and next.. that means we want to insert new one here.
			// Don't stripslashes because they weren't put back in by fgetcsv...
			$db_output = "\"".str_replace('"','&quot ',$data[0])."\",\"$data[1]\",\"$data[2]\",\"".str_replace('"','&quot ',$data[3])."\";\n";
			fputs($fout,$db_output);	//Write out the 'picseq' record, then the new one.
			$db_output = "\"".str_replace('"','&quot ',$title)."\",\"$picture\",\"$picture\",\"".str_replace('"','&quot ',$description)."\";\n";
			fputs($fout,$db_output);	//Write the updated information
	} else {
			// Don't stripslashes because they weren't put back in by fgetcsv...
			$db_output = "\"".str_replace('"','&quot ',$data[0])."\",\"$data[1]\",\"$data[2]\",\"".str_replace('"','&quot ',$data[3])."\";\n";
			fputs($fout,$db_output);	//Write the updated information
	}
	$picseq+=10;
	$nextseq+=10;
}

fclose ($fp);		/* Close the original pictures.db */
fclose ($fout);		/* Then the new one */

chmod("$AlbumDir/pictures.dbnew",0664);		// Make sure permissions OK
if (file_exists("$AlbumDir/pictures.dbold"))	// See if there was a backup left...
{
	unlink("$AlbumDir/pictures.dbold");		// Get rid of the old one
}
copy("$AlbumDir/pictures.db","$AlbumDir/pictures.dbold");	// Save a copy 'just in case'
chmod("$AlbumDir/pictures.dbold",0664);
copy("$AlbumDir/pictures.dbnew","$AlbumDir/pictures.db");

if ($submit == "Delete Picture")	// If we are deleting, we need to delete the pictures and thumbs too
{
	unlink("$AlbumDir/pictures/$picture");
	unlink("$AlbumDir/thumbs/$picture");
}
?>
<tr>
	<td align="center" colspan=3>
		<input type="submit" name="submit" value="<?=$submit?> complete">
	</td>
</tr>
</table>
</form>
<?php
}
elseif ($submit == "UpdatePicture")
/******************************************************************
 * UPDATEPICTURE - Here when the user clicks on a thumb to update	*
 *  the information and/or title.						* 
 ******************************************************************/
{
FindAlbumInfo($albumdir);
?>
<form action="<?=$PHP_SELF?>" method="post" enctype="multipart/form-data" name="UpdateForm" onSubmit=" return grandmother()">
<table cellspacing=0 cellpadding=5 frame="box">
<tr>
	<td align="center" class="title" colspan=4>
		<i>Update Picture in</i> <?=$AlbumInfo[1]?><input type="hidden" name="albumdir" value="<?=$albumdir?>"></td>
</tr>
<?php
if (!$fp = @fopen ("$AlbumDir/pictures.db",'r') )
{
	print "$AlbumDir/pictures.db is not configured yet.";	/*Not sure how we could have gotten here */
	exit;
}

$data = fgetcsv($fp,10000); /* Skip the 'header' line */
$picseq = 10;

while ($data = fgetcsv($fp,1000) )	/* Find the picture we want to update */
{
	if ($data[2] == $picture)	//See if this is the picture we want to edit
	{					//YES--put it on the screen
		OnePicture($data[0],$data[3],$picseq,$data[2],"edit");
		break;				//Finish the while loop
	}
	$picseq+=10;
}

/* close the db file */
fclose ($fp);
/* Put up some buttons so that the user can tell what they want to do */
?>
<tr>
	<td align="center" colspan=4>
		<input type="submit" name="submit" value="Update Information" onClick="setfrom('U')">
		&nbsp;&nbsp;&nbsp;
		<input type="submit" name="submit" value="Cancel" onClick="setfrom('C')">
		&nbsp;&nbsp;&nbsp;
		<input type="submit" name="submit" value="Delete Picture" onClick="setfrom('D')">
		<input type="hidden" name="picture" value="<?=$picture?>">

	</td>
</tr>
</table>
</form>
<?php
} elseif ($submit == "Edit Pictures"){
/******************************************************************
 * 'Edit Pictures' - Present a list of pictures so that the title	*
 *  description or sequence can be changed.				* 
 ******************************************************************/
FindAlbumInfo($albumdir);
?>
<form action="<?=$PHP_SELF?>" method="post" enctype="multipart/form-data">
<table cellspacing=0 cellpadding=5 frame="box">
</tr>
	<td aligh="left">
	<input type="submit" name="submit" value="Home"></td>
	<td align="center" class="title" colspan=2>
		<i>Editing pictures in:</i> <?=$AlbumInfo[1]?><input type="hidden" name="albumdir" value="<?=$albumdir?>"></td>
</tr>
<?php
// Put up the "Blank.. add picture table entries"
OnePicture("", "", "At end", NULL, "edit");
?>
<tr>
	<td align="center" colspan="3">
	<input type="submit" name="submit" value="Add Picture"></td>
</tr>
<tr>
	<td align="center" class="title" colspan=3>Click on the picture to select for editing</td>
</tr>
<?php
/* Put all the thumbs and titles/descriptions up to allow for editing */
if (!$fp = @fopen ("$AlbumDir/pictures.db",'r') )
{
	print "$AlbumDir/pictures.db is not configured yet.";
	exit;
}

$data = fgetcsv($fp,100000); /* Skip the 'header' line */
$picseq = 10;

/* pictures and data */
while ($data = fgetcsv($fp,1000) )
{
	/* write data to screen */
	OnePicture($data[0], $data[3], $picseq, $data[2], "clickable");
	$picseq+=10;
}

/* close the db file */
fclose ($fp);

?>
</table>
</form>
<?php
} elseif ($submit == "Add Album"){
/******************************************************************
 * 'Add Album' - Create the directory for a new album, and		*
 *  create the "empty" pictures.db						* 
 ******************************************************************/
	//Not a lot of editing done here... could be made better
	$thumbsize = 0+$thumbsize;	//Make it numeric
	if (!$thumbsize>0) {		//Make sure it was a good numeric
		$thumbsize = $defaultThumbScale;	//Force to be default
	}
	$albumtitle = stripslashes($albumtitle);
	$albumdesc = stripslashes($albumdesc);
	$oldumask = umask(0);		//Set the UNMASK to 0
	chdir($baseAlbumDir);
	//NOTE: This assumes that the directory name is a valid name... Probably should edit some day.
	mkdir($dirname, 01775);
	$fa = fopen("albums.db",'a');	//Add the new name to the album file
	$db_out = "\"".$dirname."\","."\"".str_replace('"','&quot ',$albumtitle)."\",".$thumbsize.",\"".str_replace('"','&quot ',$albumdesc)."\";\n";
	fputs($fa,$db_out);
	fclose($fa);
	chdir($dirname);
	$fp = fopen("pictures.db", 'w');	//Create the pictures.db
	fputs($fp,$db_out);			//This is the "dummy" header line
	fclose($fp);
	chmod("pictures.db",0664);
	mkdir("pictures",01775);
	mkdir("thumbs",01775);
	chdir("..");				//Back up to 'baseAlbum'
	chdir("..");				//Then to 'base'
	umask($oldumask);
?>
<form action="<?=$PHP_SELF?>" method="post" enctype="multipart/form-data">
<table cellspacing=0 cellpadding=5 frame="box">
</tr>
	<td aligh="left">
	<input type="submit" name="submit" value="Home"></td>
	<td align="center" class="title" colspan=2>
		Created Directory</td>
</tr>
<tr>
	<td align="right" valign="top">
	<b>Directory Name:</b></td>
	<td align="left" valign="top">
	<?=$dirname?></td>
	<td align="center" valign="top" rowspan="3">
	<b>Description:<?=$albumdesc?></td>
</tr>
<tr>
	<td align="right" valign="top">
	<b>Title:</b></td>
	<td align="left" valign="top">
	<?=$albumtitle?></td>
</tr>
<tr>
	<td align="right" valign="top">
	<b>Thumb Width:</b></td>
	<td align="left" valign="top">
	<?=$thumbsize?></td>
</tr>
<tr>
	<td align="center" colspan="3">
	<input type="submit" name="submit" value="Album Created"></td>
</tr>
<?php
} else {
/******************************************************************
 * 'default' - if $submit wasn't something we recognize, or null	*
 *  come here and put up the inital screen.				* 
 ******************************************************************/
?>
<form action="<?=$PHP_SELF?>" method="post" enctype="multipart/form-data">
<table cellspacing=0 cellpadding=5 frame="box">
	<td align="center" class="title" colspan=3>
		<b>Select album here </b><select size="1" name="albumdir">
<?php
//Retrieve the list of available albums (directories)
if (!is_dir($baseAlbumDir)) {	//Make sure basic setup done.
	$oldumask = umask(0);		//Set the UNMASK to 0
	mkdir($baseAlbumDir, 01775);	//NO - Create the base directory
	chdir($baseAlbumDir);
	$fa = fopen("albums.db",'w');	//Create the list of albums
	$db_out = "\"".$defaultAlbum."\","."\"".$defaultAlbumTitle."\",".$defaultThumbScale.",\"".$defaultAlbumDesc."\";\n";
	fputs($fa,$db_out);
	fclose($fa);
	chmod ("albums.db", 0664);
	mkdir($defaultAlbum, 01775);
	chdir($defaultAlbum);
	$fp = fopen("pictures.db", 'w');	//Create the pictures.db
	fputs($fp,$db_out);			//This is the "dummy" header line
	fclose($fp);
	chmod("pictures.db",0664);
	mkdir("pictures",01775);
	mkdir("thumbs",01775);
	chdir("..");				//Back up to 'baseAlbum'
	chdir("..");				//Then to 'base'
	umask($oldumask);
}
$sfirst = "SELECTED";
$fp = fopen("$baseAlbumDir/albums.db",'r');
while ($data = fgetcsv($fp,100000)) {		//Get the available directories
	print "<option value=\"$data[0]\" $sfirst>$data[1]";
	if ($sfirst=="SELECTED") {
		$sfirst = "";		//So only first entry has 'selected'
	}
}
fclose($fp);
print "</select>";
// Put up the "Blank.. add picture table entries"
OnePicture("", "", "At end", NULL, "edit");
?>
	</td>
</tr>
<tr>
	<td align="center" colspan="3">
	<input type="submit" name="submit" value="Add Picture"></td>
</tr>
<tr>
	<td align="center" class="title" colspan=3><b>&nbsp</b></td>
</tr>
<tr>
	<td align="center" colspan="3">
	<input type="submit" name="submit" value="Edit Pictures"></td>
</tr>
<tr>
	<td align="center" class="title" colspan=3><b>&nbsp</b></td>
</tr>
<tr>
	<td align="right" valign="top">
	<b>Directory Name:</b></td>
	<td align="left" valign="top">
	<input type="text" name="dirname" size="40" maxlength="40" ></td>
	<td align="center" valign="top" rowspan="3">
	<b>Description:</b><textarea name="albumdesc" cols="40" rows="5"></textarea></td>
</tr>
<tr>
	<td align="right" valign="top">
	<b>Title:</b></td>
	<td align="left" valign="top">
	<input type="text" name="albumtitle" size="40" maxlength="40" ></td>
</tr>
<tr>
	<td align="right" valign="top">
	<b>Thumb Width:</b></td>
	<td align="left" valign="top">
	<input type="text" name="thumbsize" size="10" maxlength="10" value="<?=$defaultThumbScale?>"></td>
</tr>
<tr>
	<td align="center" colspan="3">
	<input type="submit" name="submit" value="Add Album"></td>
</tr>
</table>
</form>
<?
}
?>

</center>
</body>
</html>
